from lxml import etree
from os.path import realpath, join, dirname

class XMLToolsXmlProcessor:
	def __init__(self, xml_file):
		try:
			self.__error_list = []
			self.xml = etree.parse(xml_file)
			path = dirname(realpath(xml_file))
			schema_file = join(path, self.xml.getroot().values()[0])
			self.xml_schema = etree.XMLSchema(etree.parse(schema_file))
			self.valid = self.validate()
		except:
			print "except!"
			self.valid = False
	
	def validate(self):
		try:
			self.xml_schema.assertValid(self.xml)
			print "xml Datei erfolgreich validiert"
			self.valid = True
			return True
		except:	
			print "error"
			log = self.xml_schema.error_log
			for error in log:
				print error
				self.__error_list.append((error.line, error.message))
			self.valid = False
			return False
	
	def xpath(self, xpath_query):
		xRes = self.xml.xpath(xpath_query)
		result = ""
		for x in xRes:
			result += etree.tostring(x) + "\n"
		return	result

	def update_document(self, new_xml = None):
		try:
			if new_xml != None:
				self.xml_file = new_xml
			self.xml = etree.parse(self.xml_file)
			path = dirname(realpath(new_xml))
			schema_file = join(path, self.xml.getroot().values()[0])
			self.xml_schema = etree.XMLSchema(etree.parse(schema_file))
			self.valid = self.validate()
		except:
			self.valid = False
	
	def get_error(self):
		return self.__error_list
	
